--- linux-3.1/fs/fuse/file.c.~1~	2011-12-06 10:10:25.000000000 +0100
+++ linux-3.1/fs/fuse/file.c	2011-12-06 10:41:23.000000000 +0100
@@ -1052,6 +1052,8 @@ ssize_t fuse_direct_io(struct file *file
 	ssize_t res = 0;
 	struct fuse_req *req;
 
+	FUSE_MIGHT_FREEZE(file->f_mapping->host->i_sb, "fuse_direct_io");
+
 	req = fuse_get_req(fc);
 	if (IS_ERR(req))
 		return PTR_ERR(req);
@@ -1832,8 +1834,6 @@ long fuse_do_ioctl(struct file *file, un
 	if (!pages || !iov_page)
 		goto out;
 
-	FUSE_MIGHT_FREEZE(inode->i_sb, "fuse_buffered_write");
-
 	/*
 	 * If restricted, initialize IO parameters as encoded in @cmd.
 	 * RETRY from server is not allowed.
@@ -2080,8 +2080,6 @@ unsigned fuse_file_poll(struct file *fil
 		fuse_register_polled_file(fc, ff);
 	}
 
-	FUSE_MIGHT_FREEZE(file->f_mapping->host->i_sb, "fuse_direct_io");
-
 	req = fuse_get_req(fc);
 	if (IS_ERR(req))
 		return POLLERR;
